<script setup lang="ts">
import type { Phenotype } from "~/utils/types/phenotype";
import { createColorScale } from "~/utils/color";

const props = withDefaults(
  defineProps<{
    phenotype: Omit<Phenotype, "id">;
    imageHeight?: number;
    variant?: "mini" | "normal" | "full";
    deletePreview?: boolean;
    submitPreview?: boolean;
  }>(),
  {
    imageHeight: 250,
    variant: "full",
    deletePreview: false,
    submitPreview: false,
  },
);

const referenceUrl = computed(() => {
  const { type, value } = props.phenotype.reference || {};
  if (!value) {
    return "";
  } else if (type === "DOI") {
    return `https://doi.org/${value}`;
  } else if (type === "PMID") {
    return `https://www.ncbi.nlm.nih.gov/pubmed/${value}`;
  } else {
    return "";
  }
});

const isIBeetle = computed(() => {
  return props.phenotype.iBeetleExperiment !== undefined;
});

const numberOfAnimals = computed(() => {
  if (props.phenotype.numberOfAnimals === undefined && isIBeetle.value) {
    return 10;
  } else {
    return props.phenotype.numberOfAnimals;
  }
});

const colorScale = createColorScale("#DD2C00", "#4CAF50", 10);
</script>

<template>
  <div>
    {{ props.phenotype.description }}
    <v-tooltip v-if="props.phenotype.penetrance !== undefined" open-delay="300">
      <template #activator="{ props: tooltipProps }">
        <v-chip
          v-bind="tooltipProps"
          size="x-small"
          density="comfortable"
          :color="colorScale[props.phenotype.penetrance * 10 - 1]"
          >{{ props.phenotype.penetrance * 100 + "%" }}</v-chip
        >
      </template>
      <span>
        {{
          props.phenotype.penetrance * 100 +
          "% of " +
          numberOfAnimals +
          " injected animals showed this phenotype"
        }}
      </span>
    </v-tooltip>

    <v-tooltip
      v-if="
        props.phenotype.dayPostInjection !== undefined &&
        (props.variant === 'full' || props.variant === 'normal')
      "
      open-delay="300"
    >
      <template #activator="{ props: tooltipProps }">
        <v-chip v-bind="tooltipProps" size="x-small" density="comfortable">
          {{ "day " + props.phenotype.dayPostInjection }}
        </v-chip>
      </template>
      <span>
        The phenotype was observed on day
        {{ props.phenotype.dayPostInjection }} after the injection
      </span>
    </v-tooltip>
    <template v-if="props.variant === 'full' || props.variant === 'normal'">
      <span
        v-for="structure in (props.phenotype.structures || []).filter(
          (s) => s.termId,
        )"
        :key="structure.termId"
      >
        <NuxtLink :to="`/ontology?id=${structure.termId?.replace(':', '_')}`">
          <v-chip size="x-small" density="comfortable">
            {{ structure.termId }}
          </v-chip>
          <!-- <v-icon size="small" color="accent" class="mr-1"> mdi-graph </v-icon> -->
        </NuxtLink>
      </span>
    </template>
  </div>
  <div v-if="props.variant === 'full'" class="text-body-2">
    <span class="text-medium-emphasis">Injected stage: </span>
    <span>{{ props.phenotype.injectedStage }}</span>
    <v-divider vertical class="mx-2 d-inline"></v-divider>
    <template v-if="props.phenotype.injectedStrain">
      <span class="text-medium-emphasis">Strain: </span>
      <span>{{ props.phenotype.injectedStrain }}</span>
      <v-divider vertical class="mx-2 d-inline"></v-divider>
    </template>
    <template v-if="props.phenotype.reference">
      <span class="text-medium-emphasis"
        >{{ props.phenotype.reference.type }}:
      </span>
      <span
        ><OutLink :to="referenceUrl" :text="props.phenotype.reference.value"
      /></span>
      <v-divider vertical class="mx-2 d-inline"></v-divider>
    </template>
    <v-dialog scrollable max-width="420px">
      <template #activator="{ props: dialogProps }">
        <span
          v-bind="dialogProps"
          class="text-medium-emphasis"
          style="cursor: pointer"
        >
          <v-icon icon="mdi-dots-horizontal" size="x-small" />
        </span>
      </template>
      <v-card>
        <v-card-title>{{ props.phenotype.description }}</v-card-title>
        <v-card-text class="text-subtitle-2" style="max-height: 420px">
          <v-table>
            <tbody>
              <tr>
                <td>dsRNA:</td>
                <td>
                  <TextDownloader
                    v-if="props.phenotype.dsRNA.sequence"
                    :text="props.phenotype.dsRNA.sequence"
                    btn-variant="outlined"
                  />
                </td>
              </tr>
              <template v-if="props.phenotype.reference">
                <tr>
                  <td>{{ props.phenotype.reference.type }}</td>
                  <td>
                    <OutLink
                      :to="referenceUrl"
                      :text="props.phenotype.reference.value"
                    />
                  </td>
                </tr>
              </template>
              <tr>
                <td>Injected stage:</td>
                <td>{{ props.phenotype.injectedStage }}</td>
              </tr>
              <tr>
                <td>Penetrance:</td>
                <td>
                  {{
                    props.phenotype.penetrance !== undefined
                      ? props.phenotype.penetrance * 100 + "%"
                      : ""
                  }}
                </td>
              </tr>
              <tr>
                <td>Strain:</td>
                <td>{{ props.phenotype.injectedStrain }}</td>
              </tr>
              <tr>
                <td>Concentration:</td>
                <td>{{ props.phenotype.concentration }} µg/µl</td>
              </tr>
              <tr>
                <td>Number of animals analyzed:</td>
                <td>{{ props.phenotype.numberOfAnimals }}</td>
              </tr>
              <tr>
                <td>Comment:</td>
                <td>{{ props.phenotype.comment }}</td>
              </tr>
            </tbody>
          </v-table>
        </v-card-text>
      </v-card>
    </v-dialog>
  </div>
  <div
    v-if="props.phenotype.images && props.phenotype.images.length > 0"
    class="mb-2"
  >
    <template v-for="image in props.phenotype.images || []" :key="image.id">
      <ImageHolder
        :image-id="image.id"
        :status="image.status"
        :height="deletePreview ? 100 : props.imageHeight"
      />
    </template>
  </div>
</template>
